## synergy 1.4.16

=== CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Version number for Synergy
set(VERSION_MAJOR 1)
set(VERSION_MINOR 4)
set(VERSION_REV 16)
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_REV}")

# The check for 2.6 may be too strict (consider lowering).
cmake_minimum_required(VERSION 2.4.7)

# CMake complains if we don't have this.
if (COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
endif()

# We're escaping quotes in the Windows version number, because
# for some reason CMake won't do it at config version 2.4.7
# It seems that this restores the newer behaviour where define
# args are not auto-escaped.
if (COMMAND cmake_policy)
	cmake_policy(SET CMP0005 NEW)
endif()

# First, declare project (important for prerequisite checks).
project(synergy C CXX)

# put binaries in a different dir to make them easier to find.
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)

# for unix, put debug files in a separate bin "debug" dir.
# release bin files should stay in the root of the bin dir.
if (CMAKE_GENERATOR STREQUAL "Unix Makefiles")
  if (CMAKE_BUILD_TYPE STREQUAL Debug)
    set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin/debug)
    set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib/debug)
  endif()
endif()

# Set some easy to type variables.
set(root_dir ${CMAKE_SOURCE_DIR})
set(cmake_dir ${root_dir}/res)
set(bin_dir ${root_dir}/bin)
set(doc_dir ${root_dir}/doc)
set(doc_dir ${root_dir}/doc)

# Declare libs, so we can use list in linker later. There's probably 
# a more elegant way of doing this; with SCons, when you check for the
# lib, it is automatically passed to the linker.
set(libs)

# Depending on the platform, pass in the required defines.
if (UNIX)

	# For config.h, detect the libraries, functions, etc.
	include(CheckIncludeFiles)
	include(CheckLibraryExists)
	include(CheckFunctionExists)
	include(CheckTypeSize)
	include(CheckIncludeFileCXX)
	include(CheckSymbolExists)
	include(CheckCSourceCompiles)

	check_include_file_cxx(istream HAVE_ISTREAM)
	check_include_file_cxx(ostream HAVE_OSTREAM)
	check_include_file_cxx(sstream HAVE_SSTREAM)

	check_include_files(inttypes.h HAVE_INTTYPES_H)
	check_include_files(locale.h HAVE_LOCALE_H)
	check_include_files(memory.h HAVE_MEMORY_H)
	check_include_files(stdlib.h HAVE_STDLIB_H)
	check_include_files(strings.h HAVE_STRINGS_H)
	check_include_files(string.h HAVE_STRING_H)
	check_include_files(sys/select.h HAVE_SYS_SELECT_H)
	check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
	check_include_files(sys/stat.h HAVE_SYS_STAT_H)
	check_include_files(sys/time.h HAVE_SYS_TIME_H)
	check_include_files(sys/utsname.h HAVE_SYS_UTSNAME_H)
	check_include_files(unistd.h HAVE_UNISTD_H)
	check_include_files(wchar.h HAVE_WCHAR_H)

	check_function_exists(getpwuid_r HAVE_GETPWUID_R)
	check_function_exists(gmtime_r HAVE_GMTIME_R)
	check_function_exists(nanosleep HAVE_NANOSLEEP)
	check_function_exists(poll HAVE_POLL)
	check_function_exists(sigwait HAVE_POSIX_SIGWAIT)
	check_function_exists(strftime HAVE_STRFTIME)
	check_function_exists(vsnprintf HAVE_VSNPRINTF)
	check_function_exists(inet_aton HAVE_INET_ATON)
	
	# For some reason, the check_function_exists macro doesn't detect
	# the inet_aton on some pure Unix platforms (e.g. sunos5). So we
	# need to do a more detailed check and also include some extra libs.
	if (NOT HAVE_INET_ATON)

		set(CMAKE_REQUIRED_LIBRARIES nsl)
		check_c_source_compiles(
			"#include <arpa/inet.h>\n int main() { inet_aton(0, 0); }" 
			HAVE_INET_ATON_ADV)
		set(CMAKE_REQUIRED_LIBRARIES)

		if (HAVE_INET_ATON_ADV)
			
			# Override the previous fail.
			set(HAVE_INET_ATON 1)

			# Assume that both nsl and socket will be needed,
			# it seems safe to add socket on the back of nsl,
			# since socket only ever needed when nsl is needed.
			list(APPEND libs nsl socket)

		endif()

	endif()

	check_type_size(char SIZEOF_CHAR)
	check_type_size(int SIZEOF_INT)
	check_type_size(long SIZEOF_LONG)
	check_type_size(short SIZEOF_SHORT)

	# pthread is used on both Linux and Mac
	check_library_exists("pthread" pthread_create "" HAVE_PTHREAD)
	if (HAVE_PTHREAD)
		list(APPEND libs pthread)
	else()
		message(FATAL_ERROR "Missing library: pthread")
	endif()

	# curl is used on both Linux and Mac
	find_package(CURL)
	if (CURL_FOUND)
		list(APPEND libs curl)
	else()
		message(FATAL_ERROR "Missing library: curl")
	endif()
	
	if (APPLE)
		exec_program(uname ARGS -v OUTPUT_VARIABLE DARWIN_VERSION)
		string(REGEX MATCH "[0-9]+" DARWIN_VERSION ${DARWIN_VERSION})
		message(STATUS "DARWIN_VERSION=${DARWIN_VERSION}")
		if (DARWIN_VERSION LESS 9)
			# 10.4: universal (32-bit intel and power pc) 
			set(CMAKE_OSX_ARCHITECTURES "ppc;i386"
				CACHE STRING "" FORCE)
		else()
			# 10.5+: 32-bit only -- missing funcs in 64-bit os libs
			# such as GetGlobalMouse.
			set(CMAKE_OSX_ARCHITECTURES "i386"
				CACHE STRING "" FORCE)
		endif()
		
		set(CMAKE_CXX_FLAGS "--sysroot ${CMAKE_OSX_SYSROOT} ${CMAKE_CXX_FLAGS} -DGTEST_USE_OWN_TR1_TUPLE=1")

		find_library(lib_ScreenSaver ScreenSaver)
		find_library(lib_IOKit IOKit)
		find_library(lib_ApplicationServices ApplicationServices)
		find_library(lib_Foundation Foundation)
		find_library(lib_Carbon Carbon)

		list(APPEND libs
			${lib_ScreenSaver}
			${lib_IOKit}
			${lib_ApplicationServices}
			${lib_Foundation}
			${lib_Carbon}
		)

	else() # not-apple

		# add include dir for bsd (posix uses /usr/include/)
		set(CMAKE_INCLUDE_PATH "${CMAKE_INCLUDE_PATH}:/usr/local/include")

		set(XKBlib "X11/Xlib.h;X11/XKBlib.h")
		check_symbol_exists("XRRNotifyEvent" "${XKBlib};X11/extensions/Xrandr.h" HAVE_X11_EXTENSIONS_XRANDR_H)

		check_include_files("${XKBlib};X11/extensions/dpms.h" HAVE_X11_EXTENSIONS_DPMS_H)
		check_include_files("X11/extensions/Xinerama.h" HAVE_X11_EXTENSIONS_XINERAMA_H)
		check_include_files("${XKBlib};X11/extensions/XKBstr.h" HAVE_X11_EXTENSIONS_XKBSTR_H)
		check_include_files("X11/extensions/XKB.h" HAVE_XKB_EXTENSION)
		check_include_files("X11/extensions/XTest.h" HAVE_X11_EXTENSIONS_XTEST_H)
		check_include_files("${XKBlib}" HAVE_X11_XKBLIB_H)
		check_include_files("X11/extensions/XInput2.h" HAVE_XI2)

		if (HAVE_X11_EXTENSIONS_DPMS_H)
			# Assume that function prototypes declared, when include exists.
			set(HAVE_DPMS_PROTOTYPES 1)
		endif()

		if (NOT HAVE_X11_XKBLIB_H)
			message(FATAL_ERROR "Missing header: " ${XKBlib})
		endif()

		check_library_exists("SM;ICE" IceConnectionNumber "" HAVE_ICE)
		check_library_exists("Xext;X11" DPMSQueryExtension "" HAVE_Xext)
		check_library_exists("Xtst;Xext;X11" XTestQueryExtension "" HAVE_Xtst)
		check_library_exists("Xinerama" XineramaQueryExtension "" HAVE_Xinerama)
		check_library_exists("Xi" XISelectEvents "" HAVE_Xi)
		check_library_exists("Xrandr" XRRQueryExtension "" HAVE_Xrandr)

		if (HAVE_ICE)

			# Assume we have SM if we have ICE.
			set(HAVE_SM 1)
			list(APPEND libs SM ICE)

		endif()

		if (HAVE_Xtst)

			# Xtxt depends on X11.
			set(HAVE_X11)
			list(APPEND libs Xtst X11)

		else()

			message(FATAL_ERROR "Missing library: Xtst")

		endif()

		if (HAVE_Xext)
			list(APPEND libs Xext)
		endif()

		if (HAVE_Xinerama)
			list(APPEND libs Xinerama)
		else (HAVE_Xinerama)
			if (HAVE_X11_EXTENSIONS_XINERAMA_H)
				set(HAVE_X11_EXTENSIONS_XINERAMA_H 0)
				message(WARNING "Old Xinerama implementation detected, disabled")
			endif()
		endif()

		if (HAVE_Xrandr)
			list(APPEND libs Xrandr)
		endif()
    
    # this was outside of the linux scope,
    # not sure why, moving it back inside.
    if(HAVE_Xi)
      list(APPEND libs Xi)
    endif()

	endif()

	# For config.h, set some static values; it may be a good idea to make
	# these values dynamic for non-standard UNIX compilers.
	set(ACCEPT_TYPE_ARG3 socklen_t)
	set(HAVE_CXX_BOOL 1)
	set(HAVE_CXX_CASTS 1)
	set(HAVE_CXX_EXCEPTIONS 1)
	set(HAVE_CXX_MUTABLE 1)
	set(HAVE_CXX_STDLIB 1)
	set(HAVE_PTHREAD_SIGNAL 1)
	set(SELECT_TYPE_ARG1 int)
	set(SELECT_TYPE_ARG234 "(fd_set *)")
	set(SELECT_TYPE_ARG5 "(struct timeval *)")
	set(STDC_HEADERS 1)
	set(TIME_WITH_SYS_TIME 1)
	set(HAVE_SOCKLEN_T 1)

	# For config.h, save the results based on a template (config.h.in).
	configure_file(res/config.h.in ${root_dir}/config.h)

	add_definitions(-DSYSAPI_UNIX=1 -DHAVE_CONFIG_H)

	if (APPLE)
		add_definitions(-DWINAPI_CARBON=1 -D_THREAD_SAFE)
	else (APPLE)
		add_definitions(-DWINAPI_XWINDOWS=1)
	endif()

else() # not-unix

	list(APPEND libs Wtsapi32 Userenv Wininet comsuppw)

	add_definitions(
		/DWIN32
		/D_WINDOWS
		/D_CRT_SECURE_NO_WARNINGS
		/DVERSION=\"${VERSION}\"
	)
	
	if (MSVC_VERSION EQUAL 1600)
		set(SLN_FILENAME "${CMAKE_CURRENT_BINARY_DIR}/synergy.sln")
		if (EXISTS "${SLN_FILENAME}" )
			file(APPEND "${SLN_FILENAME}" "\n# This should be regenerated!\n")
		endif()
	endif()

endif()

add_subdirectory(src)
add_subdirectory(tools)

if (WIN32)
	# add /analyze in order to unconver potential bugs in the source code
	# Details: http://msdn.microsoft.com/en-us/library/fwkeyyhe.aspx
	# add /FR to generate browse information (ncb files) usefull for using IDE

	#define _BIND_TO_CURRENT_CRT_VERSION 1
	#define _BIND_TO_CURRENT_ATL_VERSION 1
	#define _BIND_TO_CURRENT_MFC_VERSION 1
	#define _BIND_TO_CURRENT_OPENMP_VERSION 1
	# next line replaced the previous 4 ones:
	#define _BIND_TO_CURRENT_VCLIBS_VERSION 1;

	# compiler: /MP - use multi cores to compile
	# added _SECURE_SCL=1 for finding bugs with iterators - http://msdn.microsoft.com/en-us/library/aa985965.aspx
	
	# common args between all vs builds
	set(VS_ARGS "/FR /MP /D _BIND_TO_CURRENT_VCLIBS_VERSION=1 /D _SECURE_SCL=1 ${VS_ARGS_EXTRA}")
	
	# we may use `cmake -D VS_ARGS_EXTRA="/analyze"` for example to specify
	# analyze mode (since we don't always want to use it; e.g. on non-team 
	# or non-x86 compiler editions where there's no support)
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${VS_ARGS}")
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${VS_ARGS}")

	# this line removes "/D NDEBUG" from release, we want them in order to
	# find bugs even on release builds.
	set(CMAKE_CXX_FLAGS_RELEASE "/MD /O2 /Ob2")

endif()

if (CONF_CPACK)

	if (WIN32)
	   message(FATAL_ERROR "CPack support for Windows has been removed.")
	endif()

	if (UNIX)
		if (APPLE)
			message(FATAL_ERROR "CPack support for Apple has been removed.")
		else ()
			install(FILES bin/synergy
				DESTINATION bin
				PERMISSIONS
				OWNER_READ OWNER_WRITE OWNER_EXECUTE
				GROUP_READ GROUP_EXECUTE
				WORLD_READ WORLD_EXECUTE)

			# install gnome menu item
			install(FILES res/synergy.desktop
				DESTINATION share/applications)
			install(FILES res/synergy.ico
				DESTINATION share/icons)
		endif()
	endif()

	# The default CPack behaviour is not to append the system processor
	# type, which is undesirable in our case, since we want to support 
	# both 32-bit and 64-bit processors.
	set(CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR})

	set(CPACK_PACKAGE_NAME "synergy")
	set(CPACK_PACKAGE_VENDOR "The Synergy Project")
	set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Synergy server and client")
	set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
	set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
	set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_REV})
	set(CPACK_PACKAGE_VERSION ${VERSION})
	set(CPACK_PACKAGE_CONTACT http://synergy-foss.org/)

=== tools/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2013 Bolton Software Ltd.
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(cryptopp_dir cryptopp562)

# only compile the crypto++ files we need.
set(cryptopp_src
	${cryptopp_dir}/3way.cpp
	${cryptopp_dir}/algparam.cpp
	${cryptopp_dir}/asn.cpp
	${cryptopp_dir}/authenc.cpp
	${cryptopp_dir}/basecode.cpp
	${cryptopp_dir}/cpu.cpp
	${cryptopp_dir}/cryptlib.cpp
	${cryptopp_dir}/des.cpp
	${cryptopp_dir}/dessp.cpp
	${cryptopp_dir}/dll.cpp
	${cryptopp_dir}/ec2n.cpp
	${cryptopp_dir}/ecp.cpp
	${cryptopp_dir}/filters.cpp
	${cryptopp_dir}/fips140.cpp
	${cryptopp_dir}/gcm.cpp
	${cryptopp_dir}/gf2n.cpp
	${cryptopp_dir}/gfpcrypt.cpp
	${cryptopp_dir}/hex.cpp
	${cryptopp_dir}/hmac.cpp
	${cryptopp_dir}/hrtimer.cpp
	${cryptopp_dir}/integer.cpp
	${cryptopp_dir}/iterhash.cpp
	${cryptopp_dir}/misc.cpp
	${cryptopp_dir}/modes.cpp
	${cryptopp_dir}/mqueue.cpp
	${cryptopp_dir}/nbtheory.cpp
	${cryptopp_dir}/oaep.cpp
	${cryptopp_dir}/osrng.cpp
	${cryptopp_dir}/pubkey.cpp
	${cryptopp_dir}/queue.cpp
	${cryptopp_dir}/randpool.cpp
	${cryptopp_dir}/rdtables.cpp
	${cryptopp_dir}/rijndael.cpp
	${cryptopp_dir}/rng.cpp
	${cryptopp_dir}/sha.cpp
)

# if 64-bit windows, compile asm file.
if (CMAKE_CL_64)
	list(APPEND cryptopp_src ${cryptopp_dir}/x64dll.asm ${cryptopp_dir}/x64masm.asm)
	
	add_custom_command(OUTPUT $(IntDir)x64dll.obj
		COMMAND ml64.exe /c /nologo /Fo$(IntDir)x64dll.obj /Zi 
		"${CMAKE_CURRENT_SOURCE_DIR}/${cryptopp_dir}/x64dll.asm"
		MAIN_DEPENDENCY ${cryptopp_dir}/x64dll.asm
		VERBATIM)
		
	add_custom_command(OUTPUT $(IntDir)x64masm.obj
		COMMAND ml64.exe /c /nologo /Fo$(IntDir)x64masm.obj /Zi 
		"${CMAKE_CURRENT_SOURCE_DIR}/${cryptopp_dir}/x64masm.asm"
		MAIN_DEPENDENCY ${cryptopp_dir}/x64masm.asm
		VERBATIM)
endif()

if (UNIX)
	add_definitions(-DCRYPTOPP_DISABLE_ASM)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O2 -pipe")
	
	if (APPLE)
		if (DARWIN_VERSION GREATER 10)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-tautological-compare")
		endif()
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
	endif()
endif()

add_library(cryptopp STATIC ${cryptopp_src})

=== src/cmd/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2011 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(synergyc)
add_subdirectory(synergys)
add_subdirectory(synergyd)
add_subdirectory(usynergy)
add_subdirectory(syntool)

if (WIN32)
  add_subdirectory(synergyp)
endif()

=== src/lib/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(arch)
add_subdirectory(base)
add_subdirectory(client)
add_subdirectory(common)
add_subdirectory(io)
add_subdirectory(ipc)
add_subdirectory(mt)
add_subdirectory(net)
add_subdirectory(platform)
add_subdirectory(server)
add_subdirectory(synergy)

if (WIN32)
	add_subdirectory(synwinhk)
	add_subdirectory(synwinxt)
endif()

=== src/cmd/synergyc/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(src
	synergyc.cpp
)

if (WIN32)
	list(APPEND src
		CMSWindowsClientTaskBarReceiver.cpp
		CMSWindowsClientTaskBarReceiver.h
		resource.h
		synergyc.ico
		synergyc.rc
		tb_error.ico
		tb_idle.ico
		tb_run.ico
		tb_wait.ico
	)
elseif (APPLE)
	list(APPEND src COSXClientTaskBarReceiver.cpp)
elseif (UNIX)
	list(APPEND src CXWindowsClientTaskBarReceiver.cpp)	
endif()

set(inc
	../../lib/arch
	../../lib/base
	../../lib/client
	../../lib/common
	../../lib/io
	../../lib/ipc
	../../lib/mt
	../../lib/net
	../../lib/platform
	../../lib/synergy
	../../lib/synwinhk
	../../lib/synwinxt
)

if (UNIX)
	list(APPEND inc
		../../..
	)
endif()

include_directories(${inc})
add_executable(synergyc ${src})
target_link_libraries(synergyc
	arch base client common io mt net ipc platform server synergy cryptopp ${libs})

if (CONF_CPACK)
	install(TARGETS
		synergyc
		COMPONENT core
		DESTINATION bin)
endif()

=== src/cmd/synergyd/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2012 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(src
	synergyd.cpp
)

set(inc
	../../lib/arch
	../../lib/base
	../../lib/common
	../../lib/io
	../../lib/ipc
	../../lib/mt
	../../lib/net
	../../lib/platform
	../../lib/synergy
)

if (UNIX)
	list(APPEND inc
		../../..
	)
endif()

include_directories(${inc})

if (WIN32)
  add_executable(synergyd WIN32 ${src})
else()
  add_executable(synergyd ${src})
endif()

target_link_libraries(synergyd
	arch base common io ipc mt net platform synergy cryptopp ${libs})

if (CONF_CPACK)
	install(TARGETS
		synergyd
		COMPONENT core
		DESTINATION bin)
endif()

=== src/cmd/synergyp/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(src
	synergyp.cpp
)

if (WIN32)
	list(APPEND src
		CMSWindowsPortableTaskBarReceiver.cpp
		CMSWindowsPortableTaskBarReceiver.h
		resource.h
		synergyp.ico
		synergyp.rc
		tb_error.ico
		tb_idle.ico
		tb_run.ico
		tb_wait.ico
	)
elseif (APPLE)
	list(APPEND src COSXPortableTaskBarReceiver.cpp)	
elseif (UNIX)
	list(APPEND src CXWindowsPortableTaskBarReceiver.cpp)
endif()

set(inc
	../../lib/arch
	../../lib/base
	../../lib/common
	../../lib/io
	../../lib/ipc
	../../lib/mt
	../../lib/net
	../../lib/platform
	../../lib/synergy
	../../lib/server
	../../lib/synwinhk
	../../lib/synwinxt
)

if (UNIX)
	list(APPEND inc
		../../..
	)
endif()

include_directories(${inc})

if (WIN32)
	add_executable(synergyp WIN32 ${src})
else()
	add_executable(synergyp ${src})
endif()	
	
target_link_libraries(synergyp
	arch base client common io mt net ipc platform server synergy client cryptopp ${libs})

if (CONF_CPACK)
	install(TARGETS
		synergyp
		COMPONENT core
		DESTINATION bin)
endif()

=== src/cmd/synergys/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(src
	synergys.cpp
)

if (WIN32)
	list(APPEND src
		CMSWindowsServerTaskBarReceiver.cpp
		CMSWindowsServerTaskBarReceiver.h
		resource.h
		synergys.ico
		synergys.rc
		tb_error.ico
		tb_idle.ico
		tb_run.ico
		tb_wait.ico
	)
elseif (APPLE)
	list(APPEND src COSXServerTaskBarReceiver.cpp)	
elseif (UNIX)
	list(APPEND src CXWindowsServerTaskBarReceiver.cpp)
endif()

set(inc
	../../lib/arch
	../../lib/base
	../../lib/common
	../../lib/io
	../../lib/ipc
	../../lib/mt
	../../lib/net
	../../lib/platform
	../../lib/synergy
	../../lib/server
	../../lib/synwinhk
	../../lib/synwinxt
)

if (UNIX)
	list(APPEND inc
		../../..
	)
endif()

include_directories(${inc})
add_executable(synergys ${src})
target_link_libraries(synergys
	arch base client common io mt net ipc platform server synergy cryptopp ${libs})

if (CONF_CPACK)
	install(TARGETS
		synergys
		COMPONENT core
		DESTINATION bin)
endif()

=== src/cmd/syntool/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2014 Bolton Software Ltd.
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(src
	syntool.cpp
)

set(inc
	../../lib/arch
	../../lib/base
	../../lib/common
	../../lib/io
	../../lib/ipc
	../../lib/mt
	../../lib/net
	../../lib/platform
	../../lib/synergy
	../../lib/synwinhk
	../../lib/synwinxt
)

if (UNIX)
	list(APPEND inc
		../../..
	)
endif()

include_directories(${inc})
add_executable(syntool ${src})
target_link_libraries(syntool
	synergy arch base client common io ipc mt net platform server cryptopp ${libs})

if (CONF_CPACK)
	install(TARGETS
		syntool
		COMPONENT core
		DESTINATION bin)
endif()

=== src/lib/arch/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(src
	CArch.cpp
	IArchString.cpp
	XArch.cpp
	CArchConsoleStd.cpp
)

if (WIN32)

	set(inc
		CArch.h
		CArchConsoleWindows.h
		CArchDaemonWindows.h
		CArchFileWindows.h
		CArchLogWindows.h
		CArchMiscWindows.h
		CArchMultithreadWindows.h
		CArchNetworkWinsock.h
		CArchSleepWindows.h
		CArchStringWindows.h
		CArchSystemWindows.h
		CArchTaskBarWindows.h
		CArchTimeWindows.h
		CArchConsoleStd.h
		XArchWindows.h
		CMultibyte.h
		vsnprintf.h
		XArch.h
		IArchPlugin.h
		CArchPluginWindows.h
		CArchInternetWindows.h
	)

	list(APPEND src
		${inc}
		CArchConsoleWindows.cpp
		CArchDaemonWindows.cpp
		CArchFileWindows.cpp
		CArchLogWindows.cpp
		CArchMiscWindows.cpp
		CArchMultithreadWindows.cpp
		CArchNetworkWinsock.cpp
		CArchSleepWindows.cpp
		CArchStringWindows.cpp
		CArchSystemWindows.cpp
		CArchTaskBarWindows.cpp
		CArchTimeWindows.cpp
		XArchWindows.cpp
		CArchPluginWindows.cpp
		CArchInternetWindows.cpp
	)
	
elseif (UNIX)

	list(APPEND src
		CArchConsoleUnix.cpp
		CArchDaemonUnix.cpp
		CArchFileUnix.cpp
		CArchLogUnix.cpp
		CArchMultithreadPosix.cpp
		CArchNetworkBSD.cpp
		CArchSleepUnix.cpp
		CArchStringUnix.cpp
		CArchSystemUnix.cpp
		CArchTaskBarXWindows.cpp
		CArchTimeUnix.cpp
		XArchUnix.cpp
		CArchDaemonNone.cpp
		CArchPluginUnix.cpp
		CArchInternetUnix.cpp
	)
	
endif()

set(inc
	../base
	../common
	../mt
	../platform
	../synergy
)

if (UNIX)
	list(APPEND inc
		../../..
		../arch
	)
endif()

include_directories(${inc})
add_library(arch STATIC ${src})

=== src/lib/base/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(inc
	CEvent.h
	CEventQueue.h
	CEventTypes.h
	CFunctionEventJob.h
	CFunctionJob.h
	CLog.h
	CPriorityQueue.h
	CSimpleEventQueueBuffer.h
	CStopwatch.h
	CString.h
	CStringUtil.h
	CUnicode.h
	IEventJob.h
	IEventQueue.h
	IEventQueueBuffer.h
	IJob.h
	ILogOutputter.h
	LogOutputters.h
	TMethodEventJob.h
	TMethodJob.h
	XBase.h
	ELevel.h
)

set(src
	CEvent.cpp
	CEventQueue.cpp
	CEventTypes.cpp
	CFunctionEventJob.cpp
	CFunctionJob.cpp
	CLog.cpp
	CSimpleEventQueueBuffer.cpp
	CStopwatch.cpp
	CStringUtil.cpp
	CUnicode.cpp
	LogOutputters.cpp
	XBase.cpp
)

if (WIN32)
	list(APPEND src ${inc})
endif()

set(inc
	../arch
	../common
	../mt
	../synergy
)

if (UNIX)
	list(APPEND inc
		../../..
		../base
	)
endif()

include_directories(${inc})
add_library(base STATIC ${src})

if (UNIX)
	target_link_libraries(base common)
endif()

=== src/lib/io/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012 Bolton Software Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file COPYING that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(inc
	CStreamBuffer.h
	CStreamFilter.h
	IStream.h
	IStreamFilterFactory.h
	XIO.h
	CCryptoStream.h
	CCryptoMode.h
	ECryptoMode.h
	CCryptoOptions.h
)

set(src
	CStreamBuffer.cpp
	CStreamFilter.cpp
	XIO.cpp
	CCryptoStream.cpp
	CCryptoMode.cpp
	CCryptoOptions.cpp
)

if (WIN32)
	list(APPEND src ${inc})
endif()

set(inc
	../arch
	../base
	../common
	../..
	../../../tools
)

if (UNIX)
	list(APPEND inc
		../../..
	)
endif()

include_directories(${inc})
add_library(io STATIC ${src})

if (UNIX)
	target_link_libraries(io cryptopp)
endif()

=== debian/changelog ===
synergy (1.4.16-2) unstable; urgency=medium

  * Added ensure_non00_cursor.patch to fix a crash when synergyc starts.
    Closes: #854567
  * Updated debian/control fields: Maintainer, Homepage, Vcs-* with new
    maintainer and upstream information
  * Changed description to indicate new upstream locations for binary and
    source releases (old URL returned page not found)

 -- Joshua Honeycutt <joshua.honeycutt@gmail.com>  Wed, 08 Feb 2017 16:08:21 -0600

synergy (1.4.16-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch from https://xzrq.net/x11-mouseover.patch as mentioned
    in https://github.com/symless/synergy/issues/3749#issuecomment-58855820
    to fix X11 mouse-over issue on synergy server (closes: #764389).

 -- Peter Palfrader <weasel@debian.org>  Sun, 08 Jan 2017 11:20:13 +0100

synergy (1.4.16-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Added debian_google-test.patch to build against Debian's
    google-mock and libgtest-dev packages. Closes: #812303

 -- Joshua Honeycutt <joshua.honeycutt@gmail.com>  Sun, 23 Oct 2016 23:36:22 -0500

synergy (1.4.16-1) unstable; urgency=low

  * New upstream version.
  * Update Standards-Version.
  * Switch from docbook-to-man to docbook-utils for SGML man
    page processing.
  * Switch package version control from bzr to git.
  * Update man pages to note loss of --crypto-mode.
  * Add notes about the security of synergy's native crypto.
  * Remove faulty example.  Closes: #726526.
  * Tested Qt GUI, which works fine.  Closes: #415604.
  * Disable nag warning about newer upstream versions.  Closes: #731773.
  * Update watch file.

 -- Jeff Licquia <licquia@debian.org>  Sun, 16 Mar 2014 22:58:26 +0000

=== debian/control ===
Source: synergy
Section: x11
Priority: optional
Maintainer: Joshua Honeycutt <joshua.honeycutt@gmail.com>
Homepage: https://symless.com/synergy/
Vcs-Git: https://github.com/epakai/synergy-debian.git
Vcs-Browser: https://github.com/epakai/synergy-debian
Build-Depends: debhelper (>= 7), libxt-dev, libxtst-dev, libxinerama-dev, cmake, docbook-utils, libcrypto++-dev, pkg-config, libqt4-dev, libcurl4-gnutls-dev | libcurl-dev, google-mock, libgtest-dev
Standards-Version: 3.9.5

Package: synergy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Share mouse, keyboard and clipboard over the network
 Synergy lets you easily share a single mouse and keyboard between
 multiple computers with different operating systems, each with its
 own display, without special hardware.  It's intended for users
 with multiple computers on their desk since each system uses its
 own display.
 .
 Redirecting the mouse and keyboard is as simple as moving the mouse
 off the edge of your screen.  Synergy also merges the clipboards of
 all the systems into one, allowing cut-and-paste between systems.
 Furthermore, it synchronizes screen savers so they all start and stop
 together and, if screen locking is enabled, only one screen requires
 a password to unlock them all.
 .
 Packages for Windows/MacOS/RPM are available for paid members at 
 https://symless.com/synergy/
 .
 Sources can be found at
 https://github.com/symless/synergy/releases

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

http://synergy-foss.org/download/\?list \?file=synergy-([\d\.]+)-.*-Source\.tar\.gz
